#include "qOperators.h"


QdObject_var QdAbsValue( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QplugReturnStatus	status      = QPLUG_SUCCESS;;
    int                 nQarStatus;
	QdObject_var        qdResult;
	char*               attrPtr     = NULL;
	char*               stringBuf   = NULL;

	if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }


	// do arithmetic...
	qdResult = abs( qdOperand1 );
	if (qdResult.is_nil())
	{
		rqstrErrorMsg = QString ( "The Operation absolute value is not yet supported for this input type" );
		return ( qdResult );
	}

	// Add timeline if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt );
	}


	// Set QSAS essential attributes

	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	if( strcmp( attrPtr, "" ) != 0 )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr, qdResult );
	}

	// Frame
	QuSetFrame( qdResult, QuGetFrameAttr( qdOperand1 ) );

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( strcmp( attrPtr, "" ) != 0 )
	{
		QuSetTxtAttr( "UNITS", attrPtr, qdResult );
	}


	return ( qdResult );
}


