#include "qOperators.h"


QdObject_var QdChSign( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

	QplugReturnStatus	status      = QPLUG_SUCCESS;;
	QdObject_var        qdResult;
	char*               attrPtr     = NULL;
	char*               stringBuf   = NULL;

	if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
		QcalcAppendTextDisplay( "Change Signe operation error: Operand object is NULL" );
        return ( qdResult );
    }

	// do arithmetic...
	try
	{
		qdResult = - qdOperand1;
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "This Operation Change Sign is not yet supported between these input types");
		rqstrErrorMsg = QString( "This Operation Change Sign is not yet supported between these input types");
		return ( qdResult );
	}

	if (qdResult.is_nil())
	{
		QcalcAppendTextDisplay( "This Operation change signe is not yet supported for this input type" );
		rqstrErrorMsg = QString ( "This Operation change signe is not yet supported for this input type" );
		return ( qdResult );
	}

	// Add timeline if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt );
	}


	// Set QSAS essential attributes

	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	if( strcmp( attrPtr, "" ) != 0 )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr, qdResult );
	}

	// Frame
	const char *frPtr = QuGetFrameAttr( qdOperand1 );
	if( strcmp( frPtr, "" ) != 0 )
	{
		QuSetFrame(qdResult, frPtr );
	}

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( strcmp( attrPtr, "" ) != 0 )
	{
		QuSetTxtAttr( "UNITS", attrPtr, qdResult );
	}

	// DEPEND_i
    if (qdOperand1->xref_exists(DEPEND_1)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_1);
        qdResult->set_xref( DEPEND_1, d1_xref  );
    }
   
    if (qdOperand1->xref_exists(DEPEND_2)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_2);
        qdResult->set_xref( DEPEND_2, d1_xref  );
    }

    if (qdOperand1->xref_exists(DEPEND_3)) 
    {
        QdObject_var d1_xref = qdOperand1->get_xref(DEPEND_3);
        qdResult->set_xref( DEPEND_3, d1_xref  );
    }
    
	return ( qdResult );
}


