#include "qOperators.h"


 QdObject_var QdMod( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
	// The qdResult object is NULL at this point
        return ( qdResult );
    }

	char* attrPtr;
	char* stringBuf;

	// do arithmetic...
	try
	{
		qdResult = mod( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation Mod is not yet supported for this input type");
		rqstrErrorMsg = QString( "The operation Mod is not yet supported for this input type");
		return ( qdResult );
	}

	if ( qdResult.is_nil() )
	{
		QcalcAppendTextDisplay( "Arithmetic>> Mod Operation is not supported for this input type" );
		rqstrErrorMsg = QString( "Arithmetic>> Mod Operation is not supported for this input type" );
		return ( qdResult );
	}

	// Add timeline if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt );
	}
	
	// Set QSAS essential attributes
	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	QuSetTxtAttr( "SI_conversion", attrPtr, qdResult );

	// Frame
	// output is always a scalar
	QuSetFrame(qdResult , "scalar" );

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( strcmp( attrPtr, "" ) != 0 )
	{
		QuSetTxtAttr( "UNITS", attrPtr, qdResult );
	}

	return ( qdResult );
}





