#include "qOperators.h"


QdObject_var QdCos( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdcosLocal,
                                              qdOperand1,
	  	  	                      	      qdOperand2,
                                              rqstrErrorMsg,
		 	                      new QdString(  "cos(" ),
					      false
			                 );

      return ( qdResult );
}

QdObject_var QdSin( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdsinLocal,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "sin(" ),
											  false
							                );

    return ( qdResult );
}

QdObject_var QdTan( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdTangent,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							           new QdString(  "tan(" ),
									 false
							                 );

    return ( qdResult );
}

QdObject_var QdCot( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdCTangent,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "cot(" ),
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdCosh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction ( &QdcoshLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "cosh(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdSinh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult = QdTrigFunction (  &QdsinhLocal,
                                               qdOperand1,
							                   qdOperand2,
                                               rqstrErrorMsg,
							                   new QdString(  "sinh(" ),
											   false,
											   true
							                 );

    return ( qdResult );
}

QdObject_var Qdtanh( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

  QdObject_var  qdResult = QdTrigFunction (   &QdTangentH,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "tanh(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdCoth( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdCTangentH,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "coth(" ),
											  false,
											  true
							                 );

    return ( qdResult );
}


QdObject_var QdaCos(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcosLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acos(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaSin(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAsinLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "asin(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaTan(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAtanLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "atan(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaTan2(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{
	QdObject_var  qdResult = QuCleanObject( atan2( qdOperand1, qdOperand2 ) );

	char* SIconvr = "1 > radian" ;


	if ( ( qdResult.is_nil() ) || ( is_empty( qdResult ) ) )
	{
		rqstrErrorMsg =  QString( "Error>> invalid input to the trigonometry function. Empty object returned." );
		QcalcAppendTextDisplay( "Error>> invalid input to the trigonometry function.. Empty object returned" );
		return ( qdResult );
	}

	// Set xrefs
	
	QuSetTxtAttr( "SI_conversion", SIconvr, qdResult );

	QuSetTxtAttr( "UNITS", "rad", qdResult );

	char* labl_txt1 = QuGetAttrText( "LABLAXIS", qdOperand1 );
	char* labl_txt2 = QuGetAttrText( "LABLAXIS", qdOperand2 );
	QdString_var labl_s = new QdString( "atan2(" );


	*labl_s += labl_txt1;
	*labl_s += ", ";
	*labl_s += labl_txt2;
	*labl_s += ")";

	char* labl_s_rep = str_dup( *labl_s, labl_s->length() );
	if ( labl_s_rep != NULL )
	{
		QuSetTxtAttr( "LABLAXIS", labl_s_rep,  qdResult );
	}

	char* fillval = QuGetAttrText( "FILLVAL", qdOperand1 );
	QuSetTxtAttr( "FILLVAL", fillval,  qdResult );

	//add time if necessary
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt);
	}

     return ( qdResult );
}

QdObject_var QdaCot(     QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcotLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acot(" ),
											  true,
											  false
							                 );

    return ( qdResult );
}

QdObject_var QdaCosh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcoshLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acosh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdaSinh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAsinhLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "asinh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var Qdatanh(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAtanhLocal,
                                              qdOperand1,
							                  qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "atanh(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}

QdObject_var QdaCoth(    QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

   QdObject_var  qdResult = QdTrigFunction (  &QdAcothLocal,
                                              qdOperand1,
							           qdOperand2,
                                              rqstrErrorMsg,
							                  new QdString(  "acoth(" ),
											  true,
											  true
							                 );

    return ( qdResult );
}


QdObject_var QdTrigFunction ( QdObjectFnPtr pFn,
                              QdObject_var  qdOperand1,
						QdObject_var  qdOperand2,
                              QString&      rqstrErrorMsg,
						QdString_var  funct,
						bool          bInverse,
						bool          bHyperbolic )
{
	QdObject_var qdResult;
	if ( ( qdOperand1.is_nil() ) || ( qdOperand2.is_nil() ) )
    {
        // The object will be empty - this should never happen
	    // The qdResult object is NULL at this point
        return ( qdResult );
    }

	if ( funct.is_nil() )
	{
		return ( qdResult );
	}

	if ( pFn == NULL )
	{
		return ( qdResult );
	}

	char*        winMsg           = new char[ 100 ];
	if ( winMsg == NULL )
	{
		return ( qdResult );
	}

	QdRScalar_var unit        = new QdRScalar( 1.0 );
	if ( unit.is_nil() )
	{
		return ( qdResult );
	}

	QdObject_var  DegToRadObj = new QdRScalar( PI_ / 180.0 );
	if ( DegToRadObj.is_nil() )
	{
		return ( qdResult );
	}

	QdObject_var  tmpObj      = qdOperand1;
	QdObject_var  anyObj      = qdOperand1;

	if ( qdOperand1.is_nil() )
	{
		QcalcAppendTextDisplay( "Error>> 1st input neither const nor sequence." );
		rqstrErrorMsg = QString( "Error>> input neither const nor sequence." );
		return ( qdResult );
	}

	QdRScalar_var qdDegRad = QdRScalar_var::narrow( qdOperand2 );
	if ( qdDegRad.is_nil() )
	{
		QcalcAppendTextDisplay( "Error>> Deg/Rad unspecified." );
		rqstrErrorMsg = QString( "Error>> Deg/Rad unspecified." );
		return ( qdResult );
	}

	int nDegRadId = ( int )( *qdDegRad );

	//-----check and read what's in the SI_conversion ----------
	static char* no_unit = "1 > unk";

	char* SItxt   =  QuGetAttrText( "SI_conversion", qdOperand1 );

	char* SIconvr = NULL;
	char* rbuf    = NULL;
	char* tmpbuf  = NULL;
	if ( strcmp( SItxt, "" ) == 0 || strcmp( SItxt, " " ) == 0 )
	{
		SIconvr = new char [ strlen( no_unit ) + 1 ];
		if ( SIconvr == NULL )
		{
			return ( qdResult );
		}
		strcpy( SIconvr, no_unit );
		sprintf( winMsg, "Data SI_conversion: %s \n", SIconvr );
	}
	else
	{
		SIconvr = new char[ strlen( SItxt ) + 1 ];
		if ( SIconvr == NULL )
		{
			return ( qdResult );
		}
		strcpy( SIconvr, SItxt );
		sprintf( winMsg, "Data SI_conversion: %s \n", SIconvr );
	}

	tmpbuf = new char[ strlen( SIconvr ) + 1 ];
	strcpy( tmpbuf, SIconvr );
	char * sepPtr = strstr( SIconvr, ">" );
	
	if( sepPtr != NULL &&  strlen(sepPtr) > 1)
	{
		sepPtr[0] = '\0';
		sepPtr++; // move past null
		
		unit = new QdRScalar( atof(tmpbuf ) );
		if ( unit.is_nil() )
		{
			return ( qdResult );
		}
		
		//pick up the RHS of the SI_conversion and put it into rbuf
		// remove white space from start
		int ic = 0;
		while(sepPtr[ic] == ' ') ic++;
		
		//remove white space from end
		while( sepPtr[strlen(sepPtr)-1] == ' ' && strlen(sepPtr)-1 > ic ) sepPtr[strlen(sepPtr)-1] = '\0';

		rbuf = new char[ strlen( &(sepPtr[ic]) ) + 8 ]; // allow for as deg message
		strcpy( rbuf, &(sepPtr[ic]) );
		
	}
	else
	{
		//  unit already set to 1.0
		
		// rhs
		rbuf = new char[ 11 ]; // allow for as deg message
		strcpy( rbuf, "unk" );
	}

	if ( rbuf == NULL )
	{
		return ( qdResult );
	}

	if ( bInverse )
	{
		if ( ( nDegRadId == DEG_ID ) || ( nDegRadId == RAD_ID ) )
		{
      		if ( bHyperbolic )
			{
				QcalcAppendTextDisplay( "Error>> output in degree/rad for non-hyperbolic functions only" );
				rqstrErrorMsg = QString( "Error>> output in degree/rad for non-hyperbolic functions only" );
				return ( qdResult );
      		}
   		}

   		if ( ( nDegRadId == DEFAULT_ID ) && ( !bHyperbolic ) )
		{
			QcalcAppendTextDisplay( "Error>> must specify degree or rad for non-hyperbolic functions." );
      		rqstrErrorMsg = QString( "Error>> must specify degree or rad for non-hyperbolic functions." );
			return ( qdResult );
   		}
	}
	else if ( !bHyperbolic )
	{
		//if nDegRadId is degree or rad than ignore SI_conversion as it probably isn't a valid angle : pulldown is set in GUI
		switch ( nDegRadId )
		{
			case DEG_ID:
				if ( strstr( rbuf, pDegYes ) == NULL )
				{
					QcalcAppendTextDisplay( "WARNING>> Ignoring invalid SI_conversion" );
					strcat(rbuf, " as deg");
				}
				else
				{
					//if there's a match, then get the right unit
					if ( *unit != 1.0 )
					{
						tmpObj  = ( ( QdObject_var) unit ) * qdOperand1;
					}
				}
				anyObj = DegToRadObj * tmpObj;//transform to rad
				break;

			case RAD_ID:
				if ( strstr( rbuf, pRadYes) == NULL )
				{
					QcalcAppendTextDisplay( "WARNING>> Ignoring invalid SI_conversion" );
					strcat(rbuf, " as rad");
				}
				else
				{
					if ( *unit != 1.0 )
					{
						anyObj = ( ( QdObject_var) unit ) * qdOperand1;
					}
				}
				break;

			case DEFAULT_ID:
				if ( strstr( rbuf, pRadYes ) != NULL )
				{
					if ( *unit != 1.0 )
					{
						anyObj  = ( ( QdObject_var )unit ) * qdOperand1;
					}
				}
				else if	( strstr( rbuf, pDegYes ) != NULL )
				{
					if ( *unit != 1.0 )
					{
						tmpObj  = ( ( QdObject_var )unit )*qdOperand1;
					}

					anyObj = DegToRadObj * tmpObj;//transform to rad
				}
				else 
				{
					//if not hyperbolic function
			
					rqstrErrorMsg = QString( "Error>> Input is neither in rad nor in degree. Please specify" );
					QcalcAppendTextDisplay( "Error>> Input is neither in rad nor in degree. Please specify" );
					return ( qdResult );
				}
				break;

		default:
				rqstrErrorMsg = QString( "ERROR>> radian/degree flag choice not set. Notify csc support" );
				QcalcAppendTextDisplay( "ERROR>> radian/degree flag choice not set. Check SI_conversion xref" );
				return ( qdResult );
				break;

		}
	}

	// DO TRIG OPERATION
	try
	{
		if ( bInverse )
		{
			qdResult = ( *pFn )( anyObj, &rqstrErrorMsg );
			if ( !rqstrErrorMsg.isEmpty() )
			{
				return ( qdResult );
			}
		}
		else
		{
			qdResult = ( *pFn )( anyObj, NULL );
		}
	}
	catch( Exception & e)
	{
		e.print_msg();
		QcalcAppendTextDisplay( e.msg().c_str() );
		rqstrErrorMsg = QString( "Error>> Nil Exception..." );
		return ( qdResult );
	}


	if ( ( qdResult.is_nil() ) || ( is_empty( qdResult ) ) )
	{
		rqstrErrorMsg =  QString( "Error>> invalid input to the trigonometry function. Empty object returned." );
		QcalcAppendTextDisplay( "Error>> invalid input to the trigonometry function.. Empty object returned" );
		return ( qdResult );
	}

	if ( bInverse )
	{
		QdRScalar_var qdRadToDeg = new QdRScalar( 180.0 / PI_ );
		if ( nDegRadId == DEG_ID ) //then transform to output to degree
		{
		qdResult = ( ( QdObject_var )qdRadToDeg ) * qdResult;
		}
	}

	// Set xrefs
	
	QdString_var newSI = new QdString( "1.0 >" );
	if ( newSI.is_nil() )
	{
		return ( qdResult );
	}

	if ( bInverse && !bHyperbolic )
	{
		if (nDegRadId == RAD_ID) *newSI += "radian";
		else if(nDegRadId == DEG_ID) *newSI += "degree";
		else *newSI += "(unknown)";
	}
	else 
	{
		*newSI += "(";
		*newSI += *funct;
		*newSI += rbuf;
		*newSI += "))";
	}
	
	char* newSI_s_rep = str_dup( *newSI, newSI->length() );
	if ( newSI_s_rep == NULL )
	{
		return ( qdResult );
	}

	QuSetTxtAttr( "SI_conversion", newSI_s_rep, qdResult );

	QdString_var unit_s = new QdString( *funct );
	if ( unit_s.is_nil() )
	{
		return ( qdResult );
	}
	
	if ( bInverse && !bHyperbolic )
	{
		if (nDegRadId == RAD_ID) *unit_s = "rad";
		else if(nDegRadId == DEG_ID) *unit_s = "deg";
		else {
			char* unit_txt = QuGetAttrText( "UNITS", qdOperand1 );
			*unit_s += unit_txt;
			*unit_s += ")";
		}
	}
	else 
	{
		char* unit_txt = QuGetAttrText( "UNITS", qdOperand1 );
		*unit_s += unit_txt;
		*unit_s += ")";
	}
	
	char* unit_s_rep = str_dup( *unit_s, unit_s->length() );
	if ( unit_s_rep == NULL )
	{
		return ( qdResult );
	}
	QuSetTxtAttr( "UNITS", unit_s_rep, qdResult );

	char* labl_txt = QuGetAttrText( "LABLAXIS", qdOperand1 );
	QdString_var labl_s = new QdString( *funct );
	if ( labl_s.is_nil() )
	{
		return ( qdResult );
	}

	*labl_s += labl_txt;
	*labl_s += ")";

	char* labl_s_rep = str_dup( *labl_s, labl_s->length() );
	if ( labl_s_rep == NULL )
	{
		return ( qdResult );
	}
	QuSetTxtAttr( "LABLAXIS", labl_s_rep,                             qdResult );

	char* fillval = QuGetAttrText( "FILLVAL", qdOperand1 );
	QuSetTxtAttr( "FILLVAL", fillval,                                qdResult );
	QuSetTxtAttr( SCALEMAX, QuGetAttrText( "SCALEMAX", qdOperand1 ), qdResult );
	QuSetTxtAttr( SCALEMIN, QuGetAttrText( "SCALEMIN", qdOperand1 ), qdResult );
	QuSetTxtAttr( SCALETYP, QuGetAttrText( "SCALETYP", qdOperand1 ), qdResult );

	//add time if necessary
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt);
	}

	// Clean up memory
	if ( SIconvr )
	{
		delete [] SIconvr;
	}

	if ( rbuf )
	{
		delete [] rbuf;
	}

	if ( tmpbuf )
	{
		delete [] tmpbuf;
	}

	if ( winMsg )
	{
		delete [] winMsg ;
	}

	if ( newSI_s_rep )
	{
		delete [] newSI_s_rep;
	}

	if ( unit_s_rep )
	{
		delete [] unit_s_rep;
	}

	return ( qdResult );
}

QdObject_var QdAcosLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdRScalar_var one = new QdRScalar( 1.0 );
	QdObject_var  tmpObj;
	QdObject_var  qdResult;

	tmpObj = abs( qdOperand1 );
	if ( tmpObj > ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acos of |data|>1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acos of |data|>1." );
		return ( qdResult );
	}

	qdResult = QuCleanObject( acos( qdOperand1 ) );
	return ( qdResult );
}

QdObject_var QdAsinLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	QdObject_var  tmpObj;


	tmpObj = abs( qdOperand1 );
	if ( tmpObj > ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acos of |data|>1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acos of |data|>1." );
		return ( qdResult );
	}

	qdResult = QuCleanObject( asin( qdOperand1 ) );
	return ( qdResult );
}

QdObject_var QdAtanLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult = QuCleanObject( atan( qdOperand1 ) );
	return ( qdResult );
}


QdObject_var QdAcotLocal(     QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	qdResult = QuCleanObject( atan( ( QdObject_var )one / qdOperand1 ) );
	return ( qdResult );
}

QdObject_var QdAcoshLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}

	if ( qdOperand1 < ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute acosh of data<1." );
		QcalcAppendTextDisplay( "Error>> Cannot compute acosh of data<1." );
		return ( qdResult );
	}

	qdResult = QuCleanObject( log( qdOperand1 + sqrt( qdOperand1*qdOperand1 - ( QdObject_var )one ) ) );
	return ( qdResult );
}

QdObject_var QdAsinhLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	qdResult = QuCleanObject( log( qdOperand1 + sqrt( qdOperand1 * qdOperand1 + ( QdObject_var )one ) ) );
	return ( qdResult );
}

QdObject_var QdAtanhLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}
	QdObject_var  tmpObj;
	QdRScalar_var half = new QdRScalar( 0.5 );
	if ( half.is_nil() )
	{
		return ( qdResult );
	}

	tmpObj = abs( qdOperand1 );
	if ( tmpObj >= ( QdObject_var )one )
	{
		*pstrErrorMsg = QString( "Error>> Cannot compute atanh of |data|>= 1" );
		QcalcAppendTextDisplay( "Error>> Cannot compute atanh of |data|>= 1" );
		return ( qdResult );
	}

	qdResult = QuCleanObject( ( QdObject_var )half * log( ( ( QdObject_var )one + qdOperand1 ) / ( ( QdObject_var )one - qdOperand1 ) ) );
	return ( qdResult );
}
  
QdObject_var QdAcothLocal(    QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult;
	QdRScalar_var one  = new QdRScalar( 1.0 );
	if ( one.is_nil() )
	{
		return ( qdResult );
	}

	QdRScalar_var half = new QdRScalar( 0.5 );
	if ( half.is_nil() )
	{
		return ( qdResult );
	}

	qdResult = QuCleanObject( ( QdObject_var )half * log( ( ( QdObject_var )one + qdOperand1 ) / ( qdOperand1 - ( QdObject_var )one ) ) );
	return ( qdResult );
}

QdObject_var QdTangent(   QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var qdResult = QuCleanObject( sin( qdOperand1 ) / cos( qdOperand1 ) );
	return ( qdResult );
}


QdObject_var QdCTangent(  QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult = QuCleanObject( cos( qdOperand1 ) / sin( qdOperand1 ) );
	return ( qdResult );
}


QdObject_var QdTangentH(  QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult = QuCleanObject( sinh( qdOperand1 ) / cosh( qdOperand1 ) );
	return ( qdResult );
}


QdObject_var QdCTangentH( QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	QdObject_var  qdResult = QuCleanObject( cosh( qdOperand1 ) / sinh( qdOperand1 ) );
	return ( qdResult );
}


QdObject_var QdcosLocal(       QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( cos( qdOperand1 ) );
}

QdObject_var QdsinLocal(       QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( sin( qdOperand1 ) );
}

QdObject_var QdcoshLocal(      QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( cosh( qdOperand1 ) );
}

QdObject_var QdsinhLocal(      QdObject_var  qdOperand1, QString* pstrErrorMsg )
{
	return ( sinh( qdOperand1 ) );
}


char* str_dup( string& s, int n )
{
	char* buf = new char[ n + 1 ];
	if ( buf == NULL )
	{
		return ( NULL );
	}

	for ( int i = 0; i  < n; i++ )
	{
		buf[i] = s[i];
	}

	buf[ n ] = '\0';
	return buf;
}






