/**********************************************************************
* SCCS id: @(#)CorCoef.h	1.1 14:32:13 12/17/98  ***********************************************************************
* PROJECT:   Cluster UK CDHF
* COMPONENT: CorCoef Correlation Coefficient Routine (for Qanlib?)
* MODULE:    CorCoef.h header file 
* LANGUAGE:  C
* PURPOSE:    header file
* DESCRIPTION:  header file
*
* HISTORY: SJ Schwartz Dec 1998
*
*/

/* CorCoef.h header file */

#ifndef CORCOEF
#define CORCOEF   /* if not defined, define and include rest of file. */

#ifdef __cplusplus
extern "C" {
#endif

/* #define VERBOSE     *//*  for extra diagnostics  */

typedef struct CorCoefpacket_s {
	int npts;
	int nlags;
	float *x;
	float *y;
	float *corcoef_results;
} CorCoefpacket;

typedef enum CorCoefReturnStatus_e {
	CORCOEF_OK,
	CORCOEF_TOO_MANY_LAGS_ERROR,
	CORCOEF_CROSS_COR_ERROR,
	CORCOEF_STATS_ERROR,
	CORCOEF_UNDEFINED
} CorCoefReturnStatus;

static char* CorCoefErrorMessage[5] = 
   { "CorCoef >> OK\n",
     "CorCoef>> Error - Too many lags requested.\n",
     "CorCoef>> Error - Cross Correlation routine returned error.\n",
     "CorCoef>> Error - Stats routine returned error\n",
     "CorCoef>> Error - Undefined - you shouldn't see this\n"};

typedef enum StatsSuccessorFailure_e {
	STATSSUCCESS=0,
	STATSFAILURE
}StatsSuccessorFailure;

/* prototypes *******************************************/


CorCoefReturnStatus Xcor(CorCoefpacket *ccpacketp);

CorCoefReturnStatus CorCoef(CorCoefpacket *ccpacketp);

StatsSuccessorFailure stats (float *x, int n, float *xbarp, float *sigmap);

#ifdef __cplusplus
}  /* end extern "C"  if inside c++ compilation  */
#endif     

#endif   /* end ifndef CORCOEF  */
