#ifndef PLOT_RENDERING_CONFIG_H
#define PLOT_RENDERING_CONFIG_H

#include "qt_version.h"
#include <qobject.h>

#include <qmainwindow.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qcombobox.h>
#include <qvalidator.h>
#include <qtooltip.h>
#include <qcheckbox.h>
#include <qfontdialog.h>
#include <qspinbox.h>

#include "qt_version.h"
#include "qprofile.h"

class PlotConfig2 : public QWidget
{
	Q_OBJECT
			
	public:
		PlotConfig2();
		
		void setSelectedProfile(QProfile * p);
		
		void updateProfile(QProfile * p);
	
	public slots:

		void changeSansFont();
		void changeSerifFont();
		void changeMonotypeFont();
		void changeDecorativeFont();
		
	protected:
		QLineEdit * sansFontEdit;
		QLineEdit * serifFontEdit;
		QLineEdit * monotypeFontEdit;
		QLineEdit * decorativeFontEdit;

		
		QLineEdit * colourTableEdit;
		
#if QT_VERSION >= 0x040300
		QCheckBox * svgFontsCheck;
#endif
		QSpinBox * lineWidthBox;
        QLineEdit * gapToleranceBox;
};

#endif
