#include <qstring.h>
#include <qtextstream.h> 
#include <qfile.h> 
#include "qt_version.h"

QString QtplReadFile(QString fileNameAndPath){

   QString fileBuff;
   
   // open qtpl file for reading
   QFile qtplFile(fileNameAndPath.latin1());
   
   if ( qtplFile.open(IO_ReadOnly) ){
   
     // read qtpl file line by line into single buffer
     // note sbuf is a member of QtplParserFile class
     
     QTextStream stream( &qtplFile );
     QString line = stream.readLine();
     int p = line.find("//");
     if (p>-1) line.truncate(p); //  remove comments on ends of lines
     fileBuff = line;
#if QT_VERSION < 0x040000
     while ( !stream.eof() ) {
#else
         while ( !stream.atEnd() ) {
#endif
         line = stream.readLine(); // line of text excluding '\n'
	 int p = line.find("//");
	 if (p>-1) line.truncate(p); //  remove comments on ends of lines
	 fileBuff += QChar('\n'); // put back new line
         fileBuff += line;
     }
     qtplFile.close();
   }
   
   return fileBuff;
}
