#include "qwui.h"
#include "Qdos.h"
#include "qdutil.h"

#include <stdio.h>


void  setStandardConstants(QguListItem *WLconsts){
	QdObject_var pi;
	QdObject_var d2r;
	QdObject_var r2d;
	QdObject_var Mu0;
	QdObject_var Eps0;
	QdObject_var q_e;
	QdObject_var e;
	QdObject_var c;
	QdObject_var m_e;
	QdObject_var m_p;
	QdObject_var k;
	QdObject_var au;
	QdObject_var Re;
	QdObject_var unit_vector;
	QdObject_var x_axis, y_axis, z_axis;

	double pi_value;
	double e_value;
	double Mu0_value;
	double Eps0_value;
	double q_e_value;
	double c_value;
	double m_e_value;
	double m_p_value;
	double k_value;
	double au_value;
	double Re_value;
	double d2r_value;
	double r2d_value;
 
	QString context;
 
	float  one_value, zero_value;
    
  
 // pi
 // _____________
 
	pi_value = (double)  4.0 *atan(1.0);
	pi  = new QdRScalar ((double) pi_value);

	QwuiPutOnWL((QdObject_var) pi,  "pi",      "Constants");
 
  // SI_conversion

   // don't set so that value can be used with anything

 // FIELDNAM
	QuSetTxtAttr( "FIELDNAM", "Value of pi", pi);
 
 // Frame
	QuSetFrame(pi, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", " ", pi);

    
// deg 2 rad
//-----------
	d2r_value = pi_value / 180.;
	d2r = new QdRScalar ((double) d2r_value);
	QwuiPutOnWL((QdObject_var) d2r, "deg2rad", "Constants"); 
   
 // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>radian degree^-1", d2r);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Degree to Radian", d2r);
 
 // Frame
	QuSetFrame( d2r, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "rad / deg", d2r);

    
	r2d_value = 180. / pi_value; 
	r2d = new QdRScalar ((double) r2d_value);
	QwuiPutOnWL((QdObject_var) r2d, "rad2deg", "Constants");
  
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1> degree radian^-1", r2d);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Radian to Degree", r2d);
 
 // Frame
	QuSetFrame( r2d, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "deg/rad", r2d);
 


  // e
 // _____________
 
	e_value = (double)  exp(1.0);
    
	e = new QdRScalar((double) e_value);

	QwuiPutOnWL((QdObject_var) e, "e", "Constants");

  // SI_conversion

   // don't set so that value can be used with anything

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Value of e = exp(1)", (QdObject_var) e);
 
 // Frame
	QuSetFrame( e, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", " ", e);
 

  // Mu_0
 // _____________
 
	Mu0_value = (double)  1.256637e-6;
    
	Mu0 = new QdRScalar ((double) Mu0_value);

	QwuiPutOnWL((QdObject_var) Mu0, "Mu_0", "Constants");

  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>H m^-1", Mu0);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Permeability of free space", Mu0);
 
 // Frame
	QuSetFrame( Mu0, "scalar>na");
  
 // UNITS
	QuSetTxtAttr( "UNITS", "H/m", Mu0);
 

  // Epsilon_0
 // _____________
 
	Eps0_value = (double)  8.85416e-12;
    
	Eps0 = new QdRScalar((double) Eps0_value);

	QwuiPutOnWL((QdObject_var) Eps0, "Epsilon_0", "Constants");
   
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>F m^-1", Eps0);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Permittivity of free space", Eps0 );
 
 // Frame
	QuSetFrame( Eps0, "scalar>na");
  
 // UNITS
	QuSetTxtAttr( "UNITS", "F/m", Eps0);
 
 
  // Electron Charge
 // _____________
 
	q_e_value = (double)  1.60210e-19;
    
	q_e = new QdRScalar((double) q_e_value);

	QwuiPutOnWL((QdObject_var) q_e, "q_e", "Constants");
 
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>C", q_e);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Electron charge", q_e);
 
 // Frame
	QuSetFrame( q_e, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "C", q_e);


 // Speed of light
 // _____________
 
	c_value = (double)  2.997925e8;
    
	c = new QdRScalar((double) c_value);

	QwuiPutOnWL((QdObject_var) c, "c", "Constants");
 
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>m s^-1", c);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "speed of light", c);
 
 // Frame
	QuSetFrame( c, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "m/s", c);
 

 // electron mass
 // _____________
 
	m_e_value = (double)  9.1091e-31;
    
	m_e = new QdRScalar((double) m_e_value);

	QwuiPutOnWL((QdObject_var) m_e, "m_e", "Constants");
  
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>kg", m_e);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "mass of electron", m_e);
 
 // Frame
	QuSetFrame( m_e, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "kg", m_e);
 
 
  //  proton mass
 // _____________
 
	m_p_value = (double)  1.67e-27;
    
	m_p = new QdRScalar((double) m_p_value);

	QwuiPutOnWL((QdObject_var) m_p, "m_p", "Constants");
 
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>kg", m_p);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "mass of proton", m_p);
 
 // Frame
	QuSetFrame( m_p, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "kg", m_p);
 

  //  Boltzman's constant
 // _____________
 
	k_value = (double)  1.38054e-23;
    
	k = new QdRScalar((double) k_value);

	QwuiPutOnWL((QdObject_var) k, "k", "Constants");
 
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>J K^-1", k);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Boltzman's constant", k);
 
 // Frame
	QuSetFrame( k, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "J/K", k);


  //  Earth Radius
 // _____________
 
	Re_value = (double)  6.3712e6;
    
	Re = new QdRScalar((double) Re_value);

	QwuiPutOnWL((QdObject_var) Re, "Re", "Constants");
 
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>m", Re);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Earth Eq radius", Re);
 
 // Frame
	QuSetFrame( Re, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "m", Re);
 

  //  Astronomical Unit
 // _____________
 
	au_value = (double)  1.495985e11;
    
	au = new QdRScalar((double) au_value);

	QwuiPutOnWL((QdObject_var) au, "au", "Constants");
  
  // SI_conversion
	QuSetTxtAttr("SI_conversion", "1>m", au);

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "Astronomical Unit", au);
 
 // Frame
	QuSetFrame( au, "scalar>na");
  
 // UNITS
	QuSetTxtAttr("UNITS", "m", au);
 

 // unit vectors
 // _____________
 
	one_value = (float) 1.0;
	zero_value = (float) 0.0;

// This is a spatial vector so must be a matrix object = (1, 0, 0)

	QdRMatrix_var x_axis_mat =  new QdRMatrix( Dim(3));
	(*x_axis_mat) = one_value, zero_value, zero_value;
	x_axis = x_axis_mat;

	QwuiPutOnWL((QdObject_var) x_axis, "Ix", "Constants");

	QdRMatrix_var y_axis_mat =  new QdRMatrix( Dim(3));
	(*y_axis_mat) = zero_value, one_value, zero_value;
	y_axis = y_axis_mat;

	QwuiPutOnWL((QdObject_var) y_axis, "Iy", "Constants");

	QdRMatrix_var z_axis_mat = new QdRMatrix( Dim(3));
	(*z_axis_mat) = zero_value, zero_value, one_value;
	z_axis = z_axis_mat;

	QwuiPutOnWL((QdObject_var) z_axis, "Iz", "Constants");

 // SI_conversion
   // don't set so that unit vectors can be used with anything

 // FIELDNAM
	QuSetTxtAttr("FIELDNAM", "unit vector (1,0,0)", x_axis);
	QuSetTxtAttr("FIELDNAM", "unit vector (0,1,0)", y_axis);
	QuSetTxtAttr("FIELDNAM", "unit vector (0,0,1)", z_axis);

 // Frame
	QuSetFrame( x_axis, "vector>gse_xyz");
	QuSetFrame( y_axis, "vector>gse_xyz");
	QuSetFrame( z_axis, "vector>gse_xyz");
	
 
 // UNITS
	QuSetTxtAttr("UNITS", " ", x_axis);
	QuSetTxtAttr("UNITS", " ", y_axis);
	QuSetTxtAttr("UNITS", " ", z_axis);
 
   // dummy calls to ensure symbols loaded for plugins
	int dummy_id;
	int cidx;

} // end setStandardConstants

