/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

//#include "qwui.h"
#include "qie.h"
#include "qie_local.h"
#include "qie_qsas.h"

extern void QuMsgBar(const char*, const char*, bool);

int n_warn;
int n_errs;
bool cefChecking;
char Nerrors[80];
/* dummy file to add links to QSAS calls not used or allowed in Qtran */


 void QieAlertBox (char * title, char * text){
    if(strcmp(QiToUpper(title), "ERROR") == 0 )
       QuMsgBar( title, text , true);
    else
       QuMsgBar( title, text , false);
    return;

}

char * QieVersion(){
static  char str[40];
  strcpy(str, QIE_VERSION); 
  return &(str[0]);
}

int QiCEFmsg (int mode, const char *txt0,
              const char *txt1,
              const char *txt2){

  /* provides output for conformance testing */
  
  if(cefChecking ){
    if(mode == 0){
      n_warn++;
      sprintf(Nerrors, "%*.d", 79, n_warn);
      /* write to message bar only if no errors, as they take precedence over warnings  */
      if(n_errs == 0) QuMsgBar( Nerrors, " CEF 2 syntax warnings, see console" , false);
    }
    else if( mode != -1 ){
      n_errs++;
      sprintf(Nerrors, "%*.d", 79, n_errs);
      QuMsgBar(Nerrors, " CEF 2 syntax errors, see console", true);
    }
    
    printf("%s ", txt0);
    printf("%s ", txt1);
    printf("%s \n", txt2);
	fflush(stdout);
  }
  else{
   /* do nothing */
  }
  return 0;
}

void initQIE(bool cef2_on){

  cefChecking = cef2_on;
  n_warn = 0;  /* initialise cef2 error count */
  n_errs = 0;  /* initialise cef2 error count */
}
